Bool - Crystal 1.16.3

# struct Bool

- Bool
- Value
- Object

##
Overview

Bool has only two possible values: `true` and `false`. They are constructed using these literals:

    true  # A Bool that is true
    false # A Bool that is false

See `Bool` literals in the language reference.

##
Defined in:

bool.cr
json/to_json.cr
primitives.cr
uri/params/to_www_form.cr
yaml/to_yaml.cr

##
Constructors

- .new(ctx : YAML::ParseContext, node : YAML::Nodes::Node)
- .new(pull : JSON::PullParser)

##
Instance Method Summary

- #!=(other : Bool) : Bool

  Returns `true` if `self` is not equal to other.

- #&(other : Bool) : Bool

  Bitwise AND.

- #==(other : Bool) : Bool

  Returns `true` if `self` is equal to other.

- #^(other : Bool) : Bool

  Exclusive OR.

- #|(other : Bool) : Bool

  Bitwise OR.

- #clone : Bool
- #hash(hasher)

  See `Object#hash(hasher)`

- #to_json(json : JSON::Builder) : Nil
- #to_s(io : IO) : Nil

  Appends `"true"` for `true` and `"false"` for `false` to the given IO.

- #to_s : String

  Returns `"true"` for `true` and `"false"` for `false`.

- #to_unsafe : LibC::Int

  Returns an integer derived from the boolean value, for interoperability with C-style booleans.

- #to_yaml(yaml : YAML::Nodes::Builder) : Nil

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(ctx : YAML::ParseContext, node : YAML::Nodes::Node) #
def self.new(pull : JSON::PullParser) #

##
Instance Method Detail

def !=(other : Bool) : Bool #

Returns `true` if `self` is not equal to other.

def &(other : Bool) : Bool #

Bitwise AND. Returns `true` if this bool and other are `true`, otherwise returns `false`.

    false & false # => false
    false & true  # => false
    true & false  # => false
    true & true   # => true

def ==(other : Bool) : Bool #

Returns `true` if `self` is equal to other.

def ^(other : Bool) : Bool #

Exclusive OR. Returns `true` if this bool is different from other, otherwise returns `false`.

    false ^ false # => false
    false ^ true  # => true
    true ^ false  # => true
    true ^ true   # => false

def |(other : Bool) : Bool #

Bitwise OR. Returns `true` if this bool or other is `true`, otherwise returns `false`.

    false | false # => false
    false | true  # => true
    true | false  # => true
    true | true   # => true

def clone : Bool #
def hash(hasher) #

See `Object#hash(hasher)`

def to_json(json : JSON::Builder) : Nil #
def to_s(io : IO) : Nil #

Appends `"true"` for `true` and `"false"` for `false` to the given IO.

def to_s : String #

Returns `"true"` for `true` and `"false"` for `false`.

def to_unsafe : LibC::Int #

Returns an integer derived from the boolean value, for interoperability with C-style booleans.

The value is `1` for `true` and `0` for `false`.

def to_yaml(yaml : YAML::Nodes::Builder) : Nil #